Index: trunk/admin.php
===================================================================
--- trunk/admin.php	(revision 1118)
+++ trunk/admin.php	(revision 1119)
@@ -93,4 +93,5 @@
     'U_RATING'=> $link_start.'rating',
     'U_CADDIE'=> $link_start.'element_set&amp;cat=caddie',
+    'U_TAGS'=> $link_start.'tags',
     'U_THUMBNAILS'=> $link_start.'thumbnail',
     'U_USERS'=> $link_start.'user_list',
Index: trunk/admin/element_set_global.php
===================================================================
--- trunk/admin/element_set_global.php	(revision 1118)
+++ trunk/admin/element_set_global.php	(revision 1119)
@@ -45,38 +45,4 @@
 
 // +-----------------------------------------------------------------------+
-// |                               functions                               |
-// +-----------------------------------------------------------------------+
-
-/**
- * returns the list of uniq keywords among given elements
- *
- * @param array element_ids
- */
-function get_elements_keywords($element_ids)
-{
-  if (0 == count($element_ids))
-  {
-    return array();
-  }
-
-  $keywords = array();
-
-  $query = '
-SELECT keywords
-  FROM '.IMAGES_TABLE.'
-  WHERE id IN ('.implode(',', $element_ids).')
-;';
-  $result = pwg_query($query);
-  while ($row = mysql_fetch_array($result))
-  {
-    if (isset($row['keywords']) and !empty($row['keywords']))
-    {
-      $keywords = array_merge($keywords, explode(',', $row['keywords']));
-    }
-  }
-  return array_unique($keywords);
-}
-
-// +-----------------------------------------------------------------------+
 // |                       global mode form submission                     |
 // +-----------------------------------------------------------------------+
@@ -112,4 +78,20 @@
   }
 
+  if (isset($_POST['add_tags']) and count($collection) > 0)
+  {
+    add_tags($_POST['add_tags'], $collection);
+  }
+
+  if (isset($_POST['del_tags']) and count($collection) > 0)
+  {
+    $query = '
+DELETE
+  FROM '.IMAGE_TAG_TABLE.'
+  WHERE image_id IN ('.implode(',', $collection).')
+    AND tag_id IN ('.implode(',', $_POST['del_tags']).')
+;';
+    pwg_query($query);
+  }
+  
   if ($_POST['associate'] != 0 and count($collection) > 0)
   {
@@ -193,9 +175,4 @@
   $dbfields = array('primary' => array('id'), 'update' => array());
 
-  if (!empty($_POST['add_keywords']) or $_POST['remove_keyword'] != '0')
-  {
-    array_push($dbfields['update'], 'keywords');
-  }
-
   $formfields = array('author', 'name', 'date_creation');
   foreach ($formfields as $formfield)
@@ -211,5 +188,5 @@
   {
     $query = '
-SELECT id, keywords
+SELECT id
   FROM '.IMAGES_TABLE.'
   WHERE id IN ('.implode(',', $collection).')
@@ -221,42 +198,4 @@
       $data = array();
       $data['id'] = $row['id'];
-
-      if (!empty($_POST['add_keywords']))
-      {
-        $data['keywords'] =
-          implode(
-            ',',
-            array_unique(
-              array_merge(
-                get_keywords(empty($row['keywords']) ? '' : $row['keywords']),
-                get_keywords($_POST['add_keywords'])
-                )
-              )
-            );
-      }
-
-      if ($_POST['remove_keyword'] != '0')
-      {
-        if (!isset($data['keywords']))
-        {
-          $data['keywords'] = empty($row['keywords']) ? '' : $row['keywords'];
-        }
-
-        $data['keywords'] =
-          implode(
-            ',',
-            array_unique(
-              array_diff(
-                get_keywords($data['keywords']),
-                array($_POST['remove_keyword'])
-                )
-              )
-            );
-
-        if ($data['keywords'] == '')
-        {
-          unset($data['keywords']);
-        }
-      }
 
       if ('set' == $_POST['author_action'])
@@ -385,22 +324,33 @@
 }
 
-$blockname = 'remove_keyword_option';
-
-$template->assign_block_vars(
-  $blockname,
-  array('VALUE'=> 0,
-        'OPTION' => '------------'
-    ));
-
-$keywords = get_elements_keywords($page['cat_elements_id']);
-
-foreach ($keywords as $keyword)
-{
-  $template->assign_block_vars(
-  $blockname,
-  array('VALUE'=> $keyword,
-        'OPTION' => $keyword
-    ));
-}
+// add tags
+$template->assign_vars(
+  array(
+    'ADD_TAG_SELECTION' => get_html_tag_selection(get_all_tags(), 'add_tags'),
+    )
+  );
+
+// remove tags
+$query = '
+SELECT tag_id, name, url_name, count(*) counter
+  FROM '.IMAGE_TAG_TABLE.'
+    INNER JOIN '.TAGS_TABLE.' ON tag_id = id
+  WHERE image_id IN ('.implode(',', $page['cat_elements_id']).')
+  GROUP BY tag_id
+  ORDER BY name ASC
+;';
+$result = pwg_query($query);
+
+$tags = array();
+while($row = mysql_fetch_array($result))
+{
+  array_push($tags, $row);
+}
+
+$template->assign_vars(
+  array(
+    'DEL_TAG_SELECTION' => get_html_tag_selection($tags, 'del_tags'),
+    )
+  );
 
 // creation date
Index: trunk/admin/element_set_unit.php
===================================================================
--- trunk/admin/element_set_unit.php	(revision 1118)
+++ trunk/admin/element_set_unit.php	(revision 1119)
@@ -104,16 +104,12 @@
       $data{'date_creation'} = $row['date_creation'];
     }
-
-    $keywords = get_keywords($_POST['keywords-'.$row['id']]);
-    if (count($keywords) > 0)
-    {
-      $data{'keywords'} = implode(',', $keywords);
-    }
-    else
-    {
-      $data{'keywords'} = '';
-    }
-
+    
     array_push($datas, $data);
+
+    // tags management
+    if (isset($_POST[ 'tags-'.$row['id'] ]))
+    {
+      set_tags($_POST[ 'tags-'.$row['id'] ], $row['id']);
+    }
   }
   
@@ -122,5 +118,5 @@
     array(
       'primary' => array('id'),
-      'update' => array('name','author','comment','date_creation','keywords')
+      'update' => array('name','author','comment','date_creation')
       ),
     $datas
@@ -193,9 +189,11 @@
   $template->assign_vars(array('NAV_BAR' => $nav_bar));
 
+  // tags
+  $all_tags = get_all_tags();
  
   $element_ids = array();
 
   $query = '
-SELECT id,path,tn_ext,name,date_creation,comment,keywords,author,file
+SELECT id,path,tn_ext,name,date_creation,comment,author,file
   FROM '.IMAGES_TABLE.'
   WHERE id IN ('.implode(',', $page['cat_elements_id']).')
@@ -211,4 +209,11 @@
     
     $src = get_thumbnail_src($row['path'], @$row['tn_ext']);
+
+    $query = '
+SELECT tag_id
+  FROM '.IMAGE_TAG_TABLE.'
+  WHERE image_id = '.$row['id'].'
+;';
+    $selected_tags = array_from_query($query, 'tag_id');
     
     // creation date
@@ -238,5 +243,10 @@
         'DESCRIPTION' => @$row['comment'],
         'DATE_CREATION_YEAR' => $year,
-        'KEYWORDS' => @$row['keywords']
+        
+        'TAG_SELECTION' => get_html_tag_selection(
+          $all_tags,
+          'tags-'.$row['id'],
+          $selected_tags
+          ),
         )
       );
Index: trunk/admin/include/functions.php
===================================================================
--- trunk/admin/include/functions.php	(revision 1118)
+++ trunk/admin/include/functions.php	(revision 1119)
@@ -270,4 +270,12 @@
   pwg_query($query);
 
+  // destruction of the links between images and tags
+  $query = '
+DELETE FROM '.IMAGE_TAG_TABLE.'
+  WHERE image_id IN (
+'.wordwrap(implode(', ', $ids), 80, "\n").')
+;';
+  pwg_query($query);
+
   // destruction of the favorites associated with the picture
   $query = '
@@ -575,23 +583,4 @@
     return '';
   }
-}
-
-/**
- * returns an array with relevant keywords found in the given string.
- *
- * Keywords must be separated by comma or space characters.
- *
- * @param string keywords_string
- * @return array
- */
-function get_keywords($keywords_string)
-{
-  return
-    array_unique(
-      preg_split(
-        '/[\s,]+/',
-        $keywords_string
-        )
-      );
 }
 
@@ -2095,4 +2084,171 @@
 
 /**
+ * Set tags to an image. Warning: given tags are all tags associated to the
+ * image, not additionnal tags.
+ *
+ * @param array tag ids
+ * @param int image id
+ * @return void
+ */
+function set_tags($tags, $image_id)
+{
+  $query = '
+DELETE
+  FROM '.IMAGE_TAG_TABLE.'
+  WHERE image_id = '.$image_id.'
+;';
+  pwg_query($query);
+
+  if (count($tags) > 0)
+  {
+    $inserts = array();
+    foreach ($tags as $tag_id)
+    {
+      array_push(
+        $inserts,
+        array(
+          'tag_id' => $tag_id,
+          'image_id' => $image_id
+          )
+        );
+    }
+    mass_inserts(
+      IMAGE_TAG_TABLE,
+      array_keys($inserts[0]),
+      $inserts
+      );
+  }
+}
+
+/**
+ * Add new tags to a set of images.
+ *
+ * @param array tag ids
+ * @param array image ids
+ * @return void
+ */
+function add_tags($tags, $images)
+{
+  if (count($tags) == 0 or count($tags) == 0)
+  {
+    return;
+  }
+  
+  // we can't insert twice the same {image_id,tag_id} so we must first
+  // delete lines we'll insert later
+  $query = '
+DELETE
+  FROM '.IMAGE_TAG_TABLE.'
+  WHERE image_id IN ('.implode(',', $images).')
+    AND tag_id IN ('.implode(',', $tags).')
+;';
+  pwg_query($query);
+
+  $inserts = array();
+  foreach ($images as $image_id)
+  {
+    foreach ($tags as $tag_id)
+    {
+      array_push(
+        $inserts,
+        array(
+          'image_id' => $image_id,
+          'tag_id' => $tag_id,
+          )
+        );
+    }
+  }
+  mass_inserts(
+    IMAGE_TAG_TABLE,
+    array_keys($inserts[0]),
+    $inserts
+    );
+}
+
+function tag_id_from_tag_name($tag_name)
+{
+  global $page;
+
+  if (isset($page['tag_id_from_tag_name_cache'][$tag_name]))
+  {
+    return $page['tag_id_from_tag_name_cache'][$tag_name];
+  }
+  
+  if (function_exists('mysql_real_escape_string'))
+  {
+    $tag_name = mysql_real_escape_string($tag_name);
+  }
+  else
+  {
+    $tag_name = mysql_escape_string($tag_name);
+  }
+
+  // does the tag already exist?
+  $query = '
+SELECT id
+  FROM '.TAGS_TABLE.'
+  WHERE name = \''.$tag_name.'\'
+;';
+  $existing_tags = array_from_query($query, 'id');
+
+  if (count($existing_tags) == 0)
+  {
+    mass_inserts(
+      TAGS_TABLE,
+      array('name', 'url_name'),
+      array(
+        array(
+          'name' => $tag_name,
+          'url_name' => str2url($tag_name),
+          )
+        )
+      );
+
+    $page['tag_id_from_tag_name_cache'][$tag_name] = mysql_insert_id();
+  }
+  else
+  {
+    $page['tag_id_from_tag_name_cache'][$tag_name] = $existing_tags[0];
+  }
+
+  return $page['tag_id_from_tag_name_cache'][$tag_name];
+}
+
+function set_tags_of($tags_of)
+{
+  if (count($tags_of) > 0)
+  {
+    $query = '
+DELETE
+  FROM '.IMAGE_TAG_TABLE.'
+  WHERE image_id IN ('.implode(',', array_keys($tags_of)).')
+;';
+    pwg_query($query);
+
+    $inserts = array();
+    
+    foreach ($tags_of as $image_id => $tag_ids)
+    {
+      foreach ($tag_ids as $tag_id)
+      {
+        array_push(
+          $inserts,
+          array(
+            'image_id' => $image_id,
+            'tag_id' => $tag_id,
+            )
+          );
+      }
+    }
+
+    mass_inserts(
+      IMAGE_TAG_TABLE,
+      array_keys($inserts[0]),
+      $inserts
+      );
+  }
+}
+
+/**
  * Do maintenance on all PWG tables
  *
@@ -2144,5 +2300,3 @@
 
 }
-
-
 ?>
Index: trunk/admin/include/functions_metadata.php
===================================================================
--- trunk/admin/include/functions_metadata.php	(revision 1118)
+++ trunk/admin/include/functions_metadata.php	(revision 1119)
@@ -51,8 +51,5 @@
   if (isset($iptc['keywords']))
   {
-    // keywords separator is the comma, nothing else. Allowed characters in
-    // keywords : [A-Za-z0-9], "-" and "_". All other characters will be
-    // considered as separators
-    $iptc['keywords'] = preg_replace('/[^\w-]+/', ',', $iptc['keywords']);
+    // keywords separator is the comma
     $iptc['keywords'] = preg_replace('/^,+|,+$/', '', $iptc['keywords']);
   }
@@ -91,4 +88,5 @@
 
   $datas = array();
+  $tags_of = array();
 
   foreach ($files as $id => $file)
@@ -124,5 +122,23 @@
         foreach (array_keys($iptc) as $key)
         {
-          $data[$key] = addslashes($iptc[$key]);
+          if ($key == 'keywords' or $key == 'tags')
+          {
+            if (!isset($tags_of[$id]))
+            {
+              $tags_of[$id] = array();
+            }
+            
+            foreach (explode(',', $iptc[$key]) as $tag_name)
+            {
+              array_push(
+                $tags_of[$id],
+                tag_id_from_tag_name($tag_name)
+                );
+            }
+          }
+          else
+          {
+            $data[$key] = addslashes($iptc[$key]);
+          }
         }
       }
@@ -158,5 +174,8 @@
         array_merge(
           $update_fields,
-          array_keys($conf['use_iptc_mapping'])
+          array_diff(
+            array_keys($conf['use_iptc_mapping']),
+            array('tags', 'keywords')
+            )
           );
     }
@@ -167,6 +186,9 @@
         'update'  => array_unique($update_fields)
         );
+    echo '<pre>'; print_r($datas); echo '</pre>';
     mass_updates(IMAGES_TABLE, $fields, $datas);
   }
+
+  set_tags_of(tags_of);
 }
 
Index: trunk/admin/picture_modify.php
===================================================================
--- trunk/admin/picture_modify.php	(revision 1118)
+++ trunk/admin/picture_modify.php	(revision 1119)
@@ -101,14 +101,4 @@
   }
 
-  $keywords = get_keywords($_POST['keywords']);
-  if (count($keywords) > 0)
-  {
-    $data{'keywords'} = implode(',', $keywords);
-  }
-  else
-  {
-    $data{'keywords'} = '';
-  }
-
   mass_updates(
     IMAGES_TABLE,
@@ -120,4 +110,9 @@
     );
 
+  set_tags(
+    isset($_POST['tags']) ? $_POST['tags'] : array(),
+    $_GET['image_id']
+    );
+
   array_push($page['infos'], l10n('Picture informations updated'));
 }
@@ -216,4 +211,12 @@
 $image_file = $row['file'];
 
+// tags
+$query = '
+SELECT tag_id
+  FROM '.IMAGE_TAG_TABLE.'
+  WHERE image_id = '.$_GET['image_id'].'
+;';
+$selected_tags = array_from_query($query, 'tag_id');
+
 // Navigation path
 
@@ -258,7 +261,9 @@
     'CREATION_DATE' => $date,
 
-    'KEYWORDS' =>
-      isset($_POST['keywords']) ?
-        stripslashes($_POST['keywords']) : @$row['keywords'],
+    'TAG_SELECTION' => get_html_tag_selection(
+      get_all_tags(),
+      'tags',
+      $selected_tags
+      ),
 
     'DESCRIPTION' =>
Index: trunk/admin/site_update.php
===================================================================
--- trunk/admin/site_update.php	(revision 1118)
+++ trunk/admin/site_update.php	(revision 1119)
@@ -716,4 +716,5 @@
   $start = get_moment();
   $datas = array();
+  $tags_of = array();
   foreach ( $files as $id=>$file )
   {
@@ -724,4 +725,23 @@
       $data['id']=$id;
       array_push($datas, $data);
+
+      foreach (array('keywords', 'tags') as $key)
+      {
+        if (isset($data[$key]))
+        {
+          if (!isset($tags_of[$id]))
+          {
+            $tags_of[$id] = array();
+          }
+        
+          foreach (explode(',', $data[$key]) as $tag_name)
+          {
+            array_push(
+              $tags_of[$id],
+              tag_id_from_tag_name($tag_name)
+              );
+          }
+        }
+      }
     }
     else
@@ -730,15 +750,28 @@
     }
   }
-  $update_fields = $site_reader->get_update_attributes();
-  $update_fields = array_merge($update_fields, array('date_metadata_update'));
-  $fields =
-      array(
-        'primary' => array('id'),
-        'update'  => array_unique($update_fields)
-        );
-  //print_r($datas);
-  if (!$simulate and count($datas)>0 )
-  {
-    mass_updates(IMAGES_TABLE, $fields, $datas);
+
+  if (!$simulate)
+  {
+    if (count($datas) > 0)
+    {
+      mass_updates(
+        IMAGES_TABLE,
+        // fields
+        array(
+          'primary' => array('id'),
+          'update'  => array_unique(
+            array_merge(
+              array_diff(
+                $site_reader->get_update_attributes(),
+                // keywords and tags fields are managed separately
+                array('keywords', 'tags')
+                ),
+              array('date_metadata_update'))
+            )
+          ),
+        $datas
+        );
+    }
+    set_tags_of($tags_of);
   }
 
Index: trunk/admin/tags.php
===================================================================
--- trunk/admin/tags.php	(revision 1119)
+++ trunk/admin/tags.php	(revision 1119)
@@ -0,0 +1,265 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | PhpWebGallery - a PHP based picture gallery                           |
+// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
+// | Copyright (C) 2003-2005 PhpWebGallery Team - http://phpwebgallery.net |
+// +-----------------------------------------------------------------------+
+// | branch        : BSF (Best So Far)
+// | file          : $RCSfile$
+// | last update   : $Date: 2006-03-09 23:46:28 +0100 (jeu, 09 mar 2006) $
+// | last modifier : $Author: rub $
+// | revision      : $Revision: 1072 $
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+if( !defined("PHPWG_ROOT_PATH") )
+{
+  die ("Hacking attempt!");
+}
+
+include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
+check_status(ACCESS_ADMINISTRATOR);
+
+// +-----------------------------------------------------------------------+
+// |                                edit tags                              |
+// +-----------------------------------------------------------------------+
+
+if (isset($_POST['submit']))
+{
+  $query = '
+SELECT name
+  FROM '.TAGS_TABLE.'
+;';
+  $existing_names = array_from_query($query, 'name');
+  
+
+  $current_name_of = array();
+  $query = '
+SELECT id, name
+  FROM '.TAGS_TABLE.'
+  WHERE id IN ('.$_POST['edit_list'].')
+;';
+  $result = pwg_query($query);
+  while ($row = mysql_fetch_array($result))
+  {
+    $current_name_of[ $row['id'] ] = $row['name'];
+  }
+  
+  $updates = array();
+  // we must not rename tag with an already existing name
+  foreach (explode(',', $_POST['edit_list']) as $tag_id)
+  {
+    if (function_exists('mysql_real_escape_string'))
+    {
+      $tag_name = mysql_real_escape_string($_POST['tag_name-'.$tag_id]);
+    }
+    else
+    {
+      $tag_name = mysql_escape_string($_POST['tag_name-'.$tag_id]);
+    }
+
+    if ($tag_name != $current_name_of[$tag_id])
+    {
+      if (in_array($tag_name, $existing_names))
+      {
+        array_push(
+          $page['errors'],
+          sprintf(
+            l10n('Tag "%s" already exist'),
+            $tag_name
+            )
+          );
+      }
+      else if (!empty($tag_name))
+      {
+        array_push(
+          $updates,
+          array(
+            'id' => $tag_id,
+            'name' => $tag_name,
+            'url_name' => str2url($tag_name),
+            )
+          );
+      }
+    }
+  }
+  mass_updates(
+    TAGS_TABLE,
+    array(
+      'primary' => array('id'),
+      'update' => array('name', 'url_name'),
+      ),
+    $updates
+    );
+}
+
+// +-----------------------------------------------------------------------+
+// |                               delete tags                             |
+// +-----------------------------------------------------------------------+
+
+if (isset($_POST['delete']) and isset($_POST['tags']))
+{
+  $query = '
+SELECT name
+  FROM '.TAGS_TABLE.'
+  WHERE id IN ('.implode(',', $_POST['tags']).')
+;';
+  $tag_names = array_from_query($query, 'name');
+  
+  $query = '
+DELETE
+  FROM '.IMAGE_TAG_TABLE.'
+  WHERE tag_id IN ('.implode(',', $_POST['tags']).')
+;';
+  pwg_query($query);
+  
+  $query = '
+DELETE
+  FROM '.TAGS_TABLE.'
+  WHERE id IN ('.implode(',', $_POST['tags']).')
+;';
+  pwg_query($query);
+  
+  array_push(
+    $page['infos'],
+    sprintf(
+      l10n('The %d following tags were deleted : %s'),
+      count($tag_names),
+      implode(', ', $tag_names)
+      )
+    );
+}
+
+// +-----------------------------------------------------------------------+
+// |                               add a tag                               |
+// +-----------------------------------------------------------------------+
+
+if (isset($_POST['add_tag']) and !empty($_POST['add_tag']))
+{
+  if (function_exists('mysql_real_escape_string'))
+  {
+    $tag_name = mysql_real_escape_string($_POST['add_tag']);
+  }
+  else
+  {
+    $tag_name = mysql_escape_string($_POST['add_tag']);
+  }
+
+  // does the tag already exist?
+  $query = '
+SELECT id
+  FROM '.TAGS_TABLE.'
+  WHERE name = \''.$tag_name.'\'
+;';
+  $existing_tags = array_from_query($query, 'id');
+
+  if (count($existing_tags) == 0)
+  {
+    mass_inserts(
+      TAGS_TABLE,
+      array('name', 'url_name'),
+      array(
+        array(
+          'name' => $tag_name,
+          'url_name' => str2url($tag_name),
+          )
+        )
+      );
+    
+    array_push(
+      $page['infos'],
+      sprintf(
+        l10n('Tag "%s" was added'),
+        $tag_name
+        )
+      );
+  }
+  else
+  {
+    array_push(
+      $page['errors'],
+      sprintf(
+        l10n('Tag "%s" already exist'),
+        $tag_name
+        )
+      );
+  }
+}
+
+// +-----------------------------------------------------------------------+
+// |                             template init                             |
+// +-----------------------------------------------------------------------+
+
+$template->set_filenames(array('tags' => 'admin/tags.tpl'));
+
+$template->assign_vars(
+  array(
+    'F_ACTION' => PHPWG_ROOT_PATH.'admin.php?page=tags'
+    )
+  );
+
+// +-----------------------------------------------------------------------+
+// |                             form creation                             |
+// +-----------------------------------------------------------------------+
+
+$template->assign_vars(
+  array(
+    'TAG_SELECTION' => get_html_tag_selection(
+      get_all_tags(),
+      'tags'
+      ),
+    )
+  );
+
+if (isset($_POST['edit']) and isset($_POST['tags']))
+{
+  $template->assign_block_vars(
+    'edit_tags',
+    array(
+      'LIST' => implode(',', $_POST['tags']),
+      )
+    );
+
+  $query = '
+SELECT id, name
+  FROM '.TAGS_TABLE.'
+  WHERE id IN ('.implode(',', $_POST['tags']).')
+;';
+  $result = pwg_query($query);
+  while ($row = mysql_fetch_array($result))
+  {
+    $name_of[ $row['id'] ] = $row['name'];
+  }
+
+  foreach ($_POST['tags'] as $tag_id)
+  {
+    $template->assign_block_vars(
+      'edit_tags.tag',
+      array(
+        'ID' => $tag_id,
+        'NAME' => $name_of[$tag_id],
+        )
+      );
+  }
+}
+
+// +-----------------------------------------------------------------------+
+// |                           sending html code                           |
+// +-----------------------------------------------------------------------+
+
+$template->assign_var_from_handle('ADMIN_CONTENT', 'tags');
+
+?>
Index: trunk/include/config_default.inc.php
===================================================================
--- trunk/include/config_default.inc.php	(revision 1118)
+++ trunk/include/config_default.inc.php	(revision 1119)
@@ -440,4 +440,16 @@
 
 // +-----------------------------------------------------------------------+
+// |                                 tags                                  |
+// +-----------------------------------------------------------------------+
+
+// full_tag_cloud_items_number: number of tags to show in the full tag
+// cloud. Only the most represented tags will be shown
+$conf['full_tag_cloud_items_number'] = 200;
+
+// tags_levels: number of levels to use for display. Each level is bind to a
+// CSS class tagLevelX.
+$conf['tags_levels'] = 10;
+
+// +-----------------------------------------------------------------------+
 // | Notification by mail                                                  |
 // +-----------------------------------------------------------------------+
@@ -456,4 +468,3 @@
 // Max mails sended on one pass
 $conf['nbm_max_mails_send'] = 35;
-
 ?>
Index: trunk/include/constants.php
===================================================================
--- trunk/include/constants.php	(revision 1118)
+++ trunk/include/constants.php	(revision 1119)
@@ -71,3 +71,5 @@
 define('USER_MAIL_NOTIFICATION_TABLE', $prefixeTable.'user_mail_notification');
 define('CATEGORIES_LINK_TABLE', $prefixeTable.'categories_link');
+define('TAGS_TABLE', $prefixeTable.'tags');
+define('IMAGE_TAG_TABLE', $prefixeTable.'image_tag');
 ?>
Index: trunk/include/functions.inc.php
===================================================================
--- trunk/include/functions.inc.php	(revision 1118)
+++ trunk/include/functions.inc.php	(revision 1119)
@@ -32,4 +32,5 @@
 include_once( PHPWG_ROOT_PATH .'include/functions_group.inc.php' );
 include_once( PHPWG_ROOT_PATH .'include/functions_html.inc.php' );
+include_once( PHPWG_ROOT_PATH .'include/functions_tag.inc.php' );
 include_once( PHPWG_ROOT_PATH .'include/functions_url.inc.php' );
 
@@ -268,4 +269,33 @@
   return $picture_size;
 }
+
+/**
+ * simplify a string to insert it into an URL
+ *
+ * based on str2url function from Dotclear
+ *
+ * @param string
+ * @return string
+ */
+function str2url($str)
+{
+  $str = strtr(
+    $str,
+    'ÀÁÂÃÄÅàáâãäåÇçÒÓÔÕÖØòóôõöøÈÉÊËèéêëÌÍÎÏìíîïÙÚÛÜùúûü¾ÝÿýÑñ',
+    'AAAAAAaaaaaaCcOOOOOOooooooEEEEeeeeIIIIiiiiUUUUuuuuYYyyNn'
+    );
+
+  $str = str_replace('Æ', 'AE', $str);
+  $str = str_replace('æ', 'ae', $str);
+  $str = str_replace('¼', 'OE', $str);
+  $str = str_replace('½', 'oe', $str);
+
+  $str = preg_replace('/[^a-z0-9_\s\'\:\/\[\]-]/','',strtolower($str));
+  $str = preg_replace('/[\s\'\:\/\[\]-]+/',' ',trim($str));
+  $res = str_replace(' ','_',$str);
+  
+  return $res;
+}
+
 //-------------------------------------------- PhpWebGallery specific functions
 
@@ -830,4 +860,3 @@
   return $available_upgrade_ids;
 }
-
 ?>
Index: trunk/include/functions_html.inc.php
===================================================================
--- trunk/include/functions_html.inc.php	(revision 1118)
+++ trunk/include/functions_html.inc.php	(revision 1119)
@@ -6,5 +6,4 @@
 // +-----------------------------------------------------------------------+
 // | branch        : BSF (Best So Far)
-// | file          : $Id$
 // | last update   : $Date$
 // | last modifier : $Author$
@@ -496,4 +495,54 @@
 
 /**
+ * Returns an HTML list of tags. It can be a multi select field or a list of
+ * checkboxes.
+ *
+ * @param string HTML field name
+ * @param array selected tag ids
+ * @return array
+ */
+function get_html_tag_selection(
+  $tags,
+  $fieldname,
+  $selecteds = array(),
+  $forbidden_categories = null
+  )
+{
+  global $conf;
+  
+  $output = '<ul class="tagSelection">';
+  foreach ($tags as $tag)
+  {
+    $output.=
+      '<li>'
+      .'<label>'
+      .'<input type="checkbox" name="'.$fieldname.'[]"'
+      .' value="'.$tag['tag_id'].'"'
+      ;
+
+    if (in_array($tag['tag_id'], $selecteds))
+    {
+      $output.= ' checked="checked"';
+    }
+    
+    $output.=
+      ' />'
+      .' '.$tag['name']
+      .'</label>'
+      .'</li>'
+      ."\n"
+      ;
+  }
+  $output.= '</ul>';
+
+  return $output;
+}
+
+function name_compare($a, $b)
+{
+  return strcmp($a['name'], $b['name']);
+}
+
+/**
  * exits the current script (either exit or redirect)
  */
Index: trunk/include/functions_search.inc.php
===================================================================
--- trunk/include/functions_search.inc.php	(revision 1118)
+++ trunk/include/functions_search.inc.php	(revision 1119)
@@ -85,5 +85,5 @@
   $clauses = array();
 
-  foreach (array('file','name','comment','keywords','author') as $textfield)
+  foreach (array('file','name','comment','author') as $textfield)
   {
     if (isset($search['fields'][$textfield]))
@@ -110,5 +110,5 @@
   if (isset($search['fields']['allwords']))
   {
-    $fields = array('file', 'name', 'comment', 'keywords', 'author');
+    $fields = array('file', 'name', 'comment', 'author');
     // in the OR mode, request bust be :
     // ((field1 LIKE '%word1%' OR field2 LIKE '%word1%')
@@ -209,11 +209,67 @@
   $search_clause = $where_separator;
 
-  if (isset($forbidden))
-  {
-    $search_clause.= "\n    AND ".$forbidden;
-  }
-
   return $search_clause;
 }
 
+/**
+ * returns the list of items corresponding to the search id
+ *
+ * @param int search id
+ * @return array
+ */
+function get_search_items($search_id)
+{
+  $items = array();
+  
+  $search_clause = get_sql_search_clause($search_id);
+  
+  if (!empty($search_clause))
+  {
+    $query = '
+SELECT DISTINCT(id)
+  FROM '.IMAGES_TABLE.'
+    INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON id = ic.image_id
+  WHERE '.$search_clause.'
+;';
+    $items = array_from_query($query, 'id');
+  }
+
+  $search = get_search_array($search_id);
+
+  if (isset($search['fields']['tags']))
+  {
+    $tag_items = get_image_ids_for_tags(
+      $search['fields']['tags']['words'],
+      $search['fields']['tags']['mode']
+      );
+
+    switch ($search['mode'])
+    {
+      case 'AND':
+      {
+        if (empty($search_clause))
+        {
+          $items = $tag_items;
+        }
+        else
+        {
+          $items = array_intersect($items, $tag_items);
+        }
+        break;
+      }
+      case 'OR':
+      {
+        $items = array_unique(
+          array_merge(
+            $items,
+            $tag_items
+            )
+          );
+        break;
+      }
+    }
+  }
+  
+  return $items;
+}
 ?>
